// Register
registerInputEvent("fxDTSBrick", "teamTestPass", "Self fxDTSBrick" TAB "Player Player" TAB "Client GameConnection" TAB "MiniGame MiniGame", 1);
registerInputEvent("fxDTSBrick", "teamTestFail", "Self fxDTSBrick" TAB "Player Player" TAB "Client GameConnection" TAB "MiniGame MiniGame", 1);

registerOutputEvent("fxDTSBrick", "doTeamTest",		"list Solo 0 Team_1 1 Team_2 2", 1);
registerOutputEvent("MiniGame", "KillTeamMembers",	"list Solo 0 Team_1 1 Team_2 2", 1);
registerOutputEvent("MiniGame", "IncTeamScore",		"list Team_1 1 Team_2 2" TAB "int -999 999", 1);
registerOutputEvent("MiniGame", "CenterPrintTeam",	"list Solo 0 Team_1 1 Team_2 2" TAB "string 200 125" TAB "int 1 5", 1);
registerOutputEvent("MiniGame", "BottomPrintTeam",	"list Solo 0 Team_1 1 Team_2 2" TAB "string 200 125" TAB "int 1 5", 1);
registerOutputEvent("MiniGame", "ChatMsgTeam",		"list Solo 0 Team_1 1 Team_2 2" TAB "string 200 125", 1);

// Input
function fxDTSBrick::teamTestPass(%brick, %client)
{
	$InputTarget_["Self"] = %brick;
	$InputTarget_["Player"] = %client.Player;
	$InputTarget_["Client"] = %client;
	
	%brick.processInputEvent("teamTestPass", %client);
}

function fxDTSBrick::teamTestFail(%brick, %client)
{
	$InputTarget_["Self"] = %brick;
	$InputTarget_["Player"] = %client.Player;
	$InputTarget_["Client"] = %client;
	
	%brick.processInputEvent("teamTestFail", %client);
}

// Output
function fxDTSBrick::doTeamTest(%brick, %test, %client)
{
	if(%client.myTeam == %test)
	{
		%brick.teamTestPass(%client);
	}
	else
	{
		%brick.teamTestFail(%client);
	}
}

function MinigameSO::killTeamMembers(%mini, %team, %client)
{
	if(%client == %mini.owner)
	{
		for(%a = 0; isObject(%mini.member[%a]); %a++)
		{
			%subClient = %mini.member[%a];
			if(isObject(%subClient.player))
			{
				%subClient.player.kill();
			}
		}
	}
}

function MinigameSO::incTeamScore(%mini, %team, %score, %client)
{
	if(%client == %mini.owner)
	{
		for(%a = 0; isObject(%mini.member[%a]); %a++)
		{
			%subClient = %mini.member[%a];
			if(%subClient.myTeam == %team && isObject(%subClient.player))
			{
				%subClient.incScore(%score);
			}
		}
	}
}

// Output - Messages
function MinigameSO::CenterPrintTeam(%mini, %team, %msg, %time, %client)
{
	for(%a = 0; isObject(%mini.member[%a]); %a++)
	{
		%subClient = %mini.member[%a];
		if(%subClient.myTeam == %team && isObject(%subClient.player))
		{
			commandToClient(%subClient, 'CenterPrint', %msg, %time);
		}
	}
}

function MinigameSO::BottomPrintTeam(%mini, %team, %msg, %time, %client)
{
	for(%a = 0; isObject(%mini.member[%a]); %a++)
	{
		%subClient = %mini.member[%a];
		if(%subClient.myTeam == %team && isObject(%subClient.player))
		{
			commandToClient(%subClient, 'BottomPrint', %msg, %time);
		}
	}
}

function MinigameSO::ChatMsgTeam(%mini, %team, %msg, %client)
{
	if(%client == %mini.owner)
	{
		for(%a = 0; isObject(%mini.member[%a]); %a++)
		{
			%subClient = %mini.member[%a];
			if(%subClient.myTeam == %team && isObject(%subClient.player))
			{
				messageClient(%subClient, '', %msg);
			}
		}
	}
}